<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */
namespace App\Http\Validators;

use App\Http\Base\Validation;

class StokkapalValidator extends Validation
{
    /**
    * this function will call before insert, you can custom as your business requirement
    * @param array $input
    * @return $this
    */
    public function beforeInsert($input){
		if(empty($input["itemId"])){
			array_push($this->error, ["itemId" => "cannot be null"]);
		}
		else{
			$lengthitemid = strlen($input["itemId"]);
			if($lengthitemid>19){
			array_push($this->error, ["itemid" => "value too long"]);
			}
		}
		$item= (new \App\Http\Models\ItemModel())
			->getQuery()->where("id","=",$input["itemId"])->first();
		if(empty($item)){
			array_push($this->error, ["itemId" => "invalid relation"]);
		}
		if(empty($input["kapalId"])){
			array_push($this->error, ["kapalId" => "cannot be null"]);
		}
		else{
			$lengthkapalid = strlen($input["kapalId"]);
			if($lengthkapalid>19){
			array_push($this->error, ["kapalid" => "value too long"]);
			}
		}
		$kapal= (new \App\Http\Models\KapalModel())
			->getQuery()->where("id","=",$input["kapalId"])->first();
		if(empty($kapal)){
			array_push($this->error, ["kapalId" => "invalid relation"]);
		}
		if(empty($input["lokasiId"])){
			array_push($this->error, ["lokasiId" => "cannot be null"]);
		}
		else{
			$lengthlokasiid = strlen($input["lokasiId"]);
			if($lengthlokasiid>19){
			array_push($this->error, ["lokasiid" => "value too long"]);
			}
		}
		$lokasiitem= (new \App\Http\Models\LokasiitemModel())
			->getQuery()->where("id","=",$input["lokasiId"])->first();
		if(empty($lokasiitem)){
			array_push($this->error, ["lokasiId" => "invalid relation"]);
		}
		if(empty($input["jumlah"])){
			array_push($this->error, ["jumlah" => "cannot be null"]);
		}
		else{
			$lengthjumlah = strlen($input["jumlah"]);
			if($lengthjumlah>10){
			array_push($this->error, ["jumlah" => "value too long"]);
			}
		}
		if(empty($input["satuan"])){
			array_push($this->error, ["satuan" => "cannot be null"]);
		}
		else{
			$lengthsatuan = strlen($input["satuan"]);
			if($lengthsatuan>50){
			array_push($this->error, ["satuan" => "value too long"]);
			}
		}
		if(empty($input["status"])){
			array_push($this->error, ["status" => "cannot be null"]);
		}
		else{
			$lengthstatus = strlen($input["status"]);
			if($lengthstatus>3){
			array_push($this->error, ["status" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before update into database, you can custom as your business requirement
    * @param array $input
    * @param $id
    * @return $this
    */
    public function beforeUpdate($input,$id){
		if(empty($input["itemId"])){
			array_push($this->error, ["itemId" => "cannot be null"]);
		}
		else{
			$lengthitemid = strlen($input["itemId"]);
			if($lengthitemid>19){
			array_push($this->error, ["itemid" => "value too long"]);
			}
		}
		if(!empty($input["itemId"])){
		$item= (new \App\Http\Models\ItemModel())
			->getQuery()->where("id","=",$input["itemId"])->first();
		if(empty($item)){
			array_push($this->error, ["itemId" => "invalid relation"]);
		}
		}
		if(empty($input["kapalId"])){
			array_push($this->error, ["kapalId" => "cannot be null"]);
		}
		else{
			$lengthkapalid = strlen($input["kapalId"]);
			if($lengthkapalid>19){
			array_push($this->error, ["kapalid" => "value too long"]);
			}
		}
		if(!empty($input["kapalId"])){
		$kapal= (new \App\Http\Models\KapalModel())
			->getQuery()->where("id","=",$input["kapalId"])->first();
		if(empty($kapal)){
			array_push($this->error, ["kapalId" => "invalid relation"]);
		}
		}
		if(empty($input["lokasiId"])){
			array_push($this->error, ["lokasiId" => "cannot be null"]);
		}
		else{
			$lengthlokasiid = strlen($input["lokasiId"]);
			if($lengthlokasiid>19){
			array_push($this->error, ["lokasiid" => "value too long"]);
			}
		}
		if(!empty($input["lokasiId"])){
		$lokasiitem= (new \App\Http\Models\LokasiitemModel())
			->getQuery()->where("id","=",$input["lokasiId"])->first();
		if(empty($lokasiitem)){
			array_push($this->error, ["lokasiId" => "invalid relation"]);
		}
		}
		if(empty($input["jumlah"])){
			array_push($this->error, ["jumlah" => "cannot be null"]);
		}
		else{
			$lengthjumlah = strlen($input["jumlah"]);
			if($lengthjumlah>10){
			array_push($this->error, ["jumlah" => "value too long"]);
			}
		}
		if(empty($input["satuan"])){
			array_push($this->error, ["satuan" => "cannot be null"]);
		}
		else{
			$lengthsatuan = strlen($input["satuan"]);
			if($lengthsatuan>50){
			array_push($this->error, ["satuan" => "value too long"]);
			}
		}
		if(empty($input["status"])){
			array_push($this->error, ["status" => "cannot be null"]);
		}
		else{
			$lengthstatus = strlen($input["status"]);
			if($lengthstatus>3){
			array_push($this->error, ["status" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before delete from database, you can custom as your business requirement
    * @param $id
    * @return $this
    */
    public function beforeDelete($id){
	return $this;

    }


}